<template>
  <div class="container d-flex justify-content-center align-items-center">
    <div class="product d-flex justify-content-center align-items-start">
      <div class="left-container">
        <RouterLink class="btn btn-primary" :to="{ name: 'home' }"
          >Retour
        </RouterLink>
        <div class="title">
          {{ product.title }} |
          <RouterLink
            class="category"
            :to="{
              name: 'category',
              params: { tag: product.category }
            }"
            >{{ product.category }}</RouterLink
          >
        </div>
        <div class="description">
          {{ product.description }}
        </div>
      </div>
      <div class="right-container">
        <div class="d-flex image justify-content-center">
          <img v-if="product.image" :src="product.image" :alt="product.title" />
          <IconProduct v-else />
        </div>
        <div class="d-flex flex-row user-ratings align-items-center">
          <div class="ratings">
            <i
              class="star"
              v-for="i in Math.round(parseFloat(product.rating?.rate))"
              :key="i"
            ></i>
            <i
              class="star grey"
              v-for="i in 5 - Math.round(parseFloat(product.rating?.rate))"
              :key="i"
            ></i>
          </div>
          <h6 class="text-muted ml-1">{{ product.rating?.rate }}</h6>
        </div>
        <h6 class="text-muted">{{ product.rating?.count }} votes</h6>

        <button @click="addToCart(product)" class="btn btn-danger w-50">
          Add to cart
        </button>
      </div>
    </div>
  </div>
</template>

<script setup>
import IconProduct from '@/components/IconProduct.vue'
import { computed } from 'vue'
import { useCartStore } from '@/stores/cart'

const props = defineProps({
  product: {
    type: Object,
    required: true
  }
})
const cartStore = useCartStore()
const { addToCart } = cartStore
const product = computed(() => props.product)
</script>

<style lang="scss" scoped>
.container {
  height: 90vh;
  min-height: 100%;
  width: 100vw;
}
.product {
  background: #eee;
  padding: 1rem;
  height: 70vh;
  .left-container,
  .right-container {
    display: flex;
    flex-direction: column;
  }
  .left-container {
    width: 70%;
  }
  .right-container {
    width: 30%;
    align-items: center;
  }
  .image img {
    width: 200px;
  }
  .title {
    font-size: 2em;
    font-weight: bold;
    .category {
      all: unset;
      &:hover {
        color: #eee;
      }
    }
  }
  .description {
    font-size: 1em;
    margin-top: 2em;
  }
}
.star {
  position: relative;

  display: inline-block;
  width: 0;
  height: 0;

  margin-left: 0.9em;
  margin-right: 0.9em;
  margin-bottom: 1.2em;

  border-right: 0.3em solid transparent;
  border-bottom: 0.7em solid #fc0;
  border-left: 0.3em solid transparent;

  /* Controlls the size of the stars. */
  font-size: 24px;

  &:before,
  &:after {
    content: '';

    display: block;
    width: 0;
    height: 0;

    position: absolute;
    top: 0.6em;
    left: -1em;

    border-right: 1em solid transparent;
    border-bottom: 0.7em solid #fc0;
    border-left: 1em solid transparent;

    transform: rotate(-35deg);
  }

  &:after {
    transform: rotate(35deg);
  }
}
</style>
